<template>
	<div>
		<SpinnerHolder class="loader" v-if="loading" :background="false"></SpinnerHolder>
		<BlankLayout class="command">
			<template slot="head">
				<CommonHeader :showBackButton="showButtons" :title="$t('myOrder')" :showIcon="showButtons" ></CommonHeader>
			</template>
			<template slot="body">
				<div class="wrapper">
					<div class="one">
						<Background class="bg-logo" :custom="true">
							<VariableLogo class="logo" :custom="true"></VariableLogo>
						</Background>
					</div>
					<div class="two">
						<h3 class="name-restaurant" v-text="nameRestaurant"></h3>
					</div>
				</div>
				<div class="info">
					<h3 class="title">
						{{ $t('OrdenConfirmada') }}
					</h3>
					<div class="container-details">
						<p>
							<b>{{ $t('name') }}:</b> {{ order.name }}
						</p>
						<p>
							<b>{{ $t('telephone') }}:</b> {{ order.phone }}
						</p>
						<p>
							<b>{{ $t('orderDate') }}:</b> {{ date }} <b>{{ $t('time') }}:</b> {{ hour }}
						</p>
						<p>
							<b>{{ $t('numberOrder') }}:</b> {{ readableId }}
						</p>
						<p>
							<b>{{ $t('address') }}:</b> {{ order.address.formatAddress }}
						</p>
					</div>
				</div>
				<ul>
					<li class="block">
						<input type="checkbox" name="item" id="item1" checked />
						<label for="item1">
							<i aria-hidden="true" class="icon-users"></i>
							{{ $t('yourOrder') }}
							<span>&#8249;</span>
						</label>
						<ul class="options">
							<li v-for="(item, index) of order.items" :key="index">
								<div class="items-container">
									<div class="item">
										<Thumbnail
											class="thumbnail"
											:style="thumbnailBorder"
											:src="item.photoURL"
										></Thumbnail>
										<div class="item-info">
											<span>{{ item.localizedName }} </span>
											<span class="small-details">Cantidad: {{ item.quantity }}</span>
										</div>
										<h2 class="number">
											{{
												formatPrice(
													(item.price.ammount + item.priceIngredients) * item.quantity,
													true
												)
											}}
										</h2>
									</div>
								</div>
							</li>
						</ul>
					</li>
				</ul>
				<div class="content-delivery">
					<b class="title"> {{ $t('delivery') }}</b
					><span class="cost">{{ formatPrice(order.deliveryCost) + ' MXN' }}</span
					><br />
					<span class="sub-title"
						>{{ deliveryEstimate ? $t('estimedDeliveryTime') + ':' : '' }} {{ deliveryEstimate }}</span
					>
				</div>
				<div class="spacer" style="padding: 7vh"></div>
				<div class="content-bottom">
					<div class="content-restart" @click="resetOrder()">
						<span class="title">+ {{ $t('newOrder') }}</span>
						<img class="icon" src="../assets/icons/icon-shopping-cart.svg" />
					</div>
					<div class="content-total">
						<b class="title">{{ $t('total') }}</b>
						<span class="cost">{{ totaltext }}</span>
						<br />
						<span class="sub-title">{{ $t('taxes') }}</span>
					</div>
				</div>
			</template>
		</BlankLayout>
	</div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator'
import CommonHeader from '@/components/CommonHeader.vue'
import Background from '@/components/Background.vue'
import VariableLogo from '@/components/VariableLogo.vue'
import Menu from '@/models/Menu'
import Thumbnail from '@/components/Thumbnail.vue'
import BlankLayout from '@/layouts/BlankLayout.vue'
import Order from '../models/Order'
import ItemIngredient from '../models/ItemIngredient'
import Address from '@/models/Address'
import { localizedDeliveryEstimate } from '@/utils/LocalizationsUtils'
import Localization from '@/models/Localization'
import { formatPrice } from '@/mixins/MenuLocalization'
import { User } from '../models/User'
import { DeliveryMenu } from '@/models/DeliveryMenu'
import { PaymentStatus } from '@/models/PaymentDetails'
import SpinnerHolder from '@/components/SpinnerHolder.vue'

@Component({
	components: {
		CommonHeader,
		VariableLogo,
		Background,
		Thumbnail,
		BlankLayout,
		SpinnerHolder
	}
})
export default class Command extends Vue {
	name = ''
	phone = ''
	date = ''
	hour = ''
	address = ''
	totaltext = ''
	visa = false
	deliveryCost = 0
	nameRestaurant = ''
	dateNow = new Date()
	showButtons = false
	order: Order | null = this.$store.state.order
	menu: Menu | null = this.$store.state.menu
	thumbnailBorder = `border: 1px ${this.$store.getters.colors.backgroundColor} solid;`
	goodEnding = false
	loading = false
	delivery: DeliveryMenu = this.$store.state.deliveryMenu
	deliveryEstimate = ''
	orderAddressStore: Address = this.$store.state.order.address
	user: User | null = this.$store.state.user

	@Prop({ default: '' })
	readonly orderId!: string
	@Prop({ default: '' })
	readonly checkoutId!: string
	@Prop({ default: '' })
	readonly paymentStatus!: string

	get readableId() {
		if (this.order?.number) {
			return '#' + this.order.number
		}
		return ''
	}

	parsePaymentStatus(status: string): PaymentStatus {
		const paymentStatus = status.toUpperCase()
		if (PaymentStatus[paymentStatus]) return PaymentStatus[paymentStatus]
		return PaymentStatus.UNKNOWN
	}

	reduceIngredients(ingredients: Array<ItemIngredient>, start: string) {
		return ingredients.reduce(
			(p, i, index, array) =>
				p +
				i.localizedNames +
				': ' +
				i.extraIngredients.map(rest => {
					if (rest.selected == true) return ' ' + rest.localizedNames
				}) +
				`${index + 1 == array.length ? '' : ', ' + start + ' '}`,
			start + ' '
		)
	}

	changeAddress() {
		this.$router.push('/maps')
	}

	created() {
		this.getInfoRest()
		this.getInfoOrder()
		this.getTotal()
		this.getEstimate()
	}

	getInfoRest() {
		const menu: Menu | undefined = this.$store.state.menu
		if (menu) {
			this.nameRestaurant = menu.name
		}
	}

	getEstimate() {
		if (this.delivery.descriptionEstimates) {
			this.deliveryEstimate = localizedDeliveryEstimate(this.delivery)
		}
	}

	getInfoOrder() {
		const phoneExt = this.$store.state.order.phoneExt
		phoneExt
			? (this.phone = this.$store.state.order.phone + ' / Ext: ' + phoneExt)
			: (this.phone = this.$store.state.order.phone)
		this.date = this.dateNow.getDate() + '-' + (this.dateNow.getMonth() + 1) + '-' + this.dateNow.getFullYear()
		this.hour = ('0' + this.dateNow.getHours()).slice(-2) + ':' + ('0' + this.dateNow.getMinutes()).slice(-2)
		this.address = this.getAddress()
	}

	getAddress() {
		if (!this.orderAddressStore) {
			this.orderAddressStore = this.$store.state.address
		}
		let addr = ''
		this.orderAddressStore.street ? (addr += this.orderAddressStore.street + ', ') : ''
		this.orderAddressStore.extNumber ? (addr += this.orderAddressStore.extNumber + ', ') : ''
		this.orderAddressStore.number ? (addr += this.orderAddressStore.number + ', ') : ''
		this.orderAddressStore.region ? (addr += this.orderAddressStore.region + ', ') : ''
		this.orderAddressStore.references ? (addr += this.orderAddressStore.references + ', ') : ''
		this.orderAddressStore.postal ? (addr += this.orderAddressStore.postal) : ''
		return addr
	}

	getTotal() {
		if (this.order) {
			if (this.$store.state.currency == 'MXN') {
				const total: number = this.order.subtotal + this.order.deliveryCost
				this.totaltext = `${formatPrice(total)} MXN`
			} else {
				let total: number = this.order.subtotal
				const delivery: number = this.order.deliveryCost
				const localizations = this.$store.state.menu.localizations
				localizations.forEach((docLocalization: Localization) => {
					if (docLocalization.currency == this.$store.state.currency) {
						total = total * parseInt(docLocalization.change) + delivery
						this.totaltext = `${formatPrice(total)} MXN`
					}
				})
			}
		} else {
			this.totaltext = ''
		}
	}

	async resetOrder() {
		await this.$store.dispatch('setNewOrder')
		this.$router.push('/menu')
	}
}
</script>

<style lang="scss" scoped>
.loader {
	position: fixed;
	z-index: 2000;
	background-color: rgba(0, 0, 0, 0.8);
}

.command {
	display: flex;
	flex-direction: column;
	// justify-content: flex-start;
	background-color: rgb(255, 255, 255);
	color: rgb(14, 14, 14);
	width: 100%;
	height: 100%;
	// overflow-y: auto;

	.wrapper {
		margin-top: 15px;
		margin-left: 18px;
		height: 65px;
		display: grid;
		grid-template-columns: repeat(12, 1fr);
		grid-gap: 10px;
		grid-auto-rows: minmax(100px, auto);
	}
	.one {
		padding-top: 10px;
		padding-left: 10px;
		// padding-right: 5%;
		grid-column: 1;
		grid-row: 1;
		height: 70px;
		width: 60px;
		.bg-logo {
			border-radius: 10px;
			float: right;
			width: 60px;
			height: 60px;
			.logo {
				max-width: 100%;
			}
		}
	}
	.two {
		float: left;
		width: 250px;
		height: 70px;
		grid-column: 2/ 12;
		.name-restaurant {
			margin-top: 30px;
			vertical-align: middle;
		}
	}
	* {
		-webkit-box-sizing: border-box;
		-moz-box-sizing: border-box;
		box-sizing: border-box;
	}
	ul {
		list-style: none;
		//margin:0;
		padding: 0;
		width: 100%;
		margin: 0 auto;

		.block {
			.options {
				li {
					.items-container {
						.item {
							margin-bottom: 20px;
							display: flex;
							width: 100%;
							justify-content: space-between;
							align-items: center;

							.thumbnail {
								width: 60px;
								height: 60px;
								border-radius: 50%;
								margin-left: 15px;
							}

							.item-info {
								display: flex;
								flex-direction: column;
								max-width: 200px;
								margin-right: auto;
								margin-left: 10px;
								font-family: 'Roboto Condensed';
								font-size: 16px;
								line-height: 19px;
								color: #000000;
								.name {
									color: #000000;
									font-size: 16px;
									line-height: 19px;
								}
								.small-details {
									font-size: 10px;
									color: #646979;
									font-size: 18px;
									line-height: 21px;
									margin: 5px 0;
								}

								.quantity {
									margin-top: 8px;
									color: #646979;
									font-size: 18px;
									line-height: 21px;
								}
							}
							.counter {
								margin-right: 15px;
							}
							.number {
								color: #feca38;
								margin-right: 10px;
							}
						}
					}
				}
			}
		}
	}
	ul li label {
		color: rgb(0, 0, 0);
		font-weight: 600;
	}
	ul li input[type='checkbox'] {
		display: none;
	}
	ul li label {
		display: block;
		padding: 12px;
		width: 100% !important;
	}
	ul li i {
		font-size: 18px;
		vertical-align: middle;
		width: 20px;
	}
	ul li label {
		background: rgb(243, 243, 243);
	}
	ul li input[type='checkbox']:checked ~ label {
		background: rgb(221, 221, 221);
	}
	ul li input[type='checkbox']:checked ~ .options {
		height: auto;
		display: block;
		min-height: 40px;
	}
	ul li label span {
		float: right;
		font-size: 25px;
		font-weight: 900;
		-webkit-transform: rotate(-90deg);
		-moz-transform: rotate(-90deg);
		-ms-transform: rotate(-90deg);
		-o-transform: rotate(-90deg);
		transform: rotate(-90deg);
		display: inline-block;
		vertical-align: middle;
	}
	ul li input[type='checkbox']:checked ~ label span {
		-webkit-transform: rotate(90deg);
		-moz-transform: rotate(90deg);
		-ms-transform: rotate(90deg);
		-o-transform: rotate(90deg);
		transform: rotate(90deg);
		display: inline-block;
	}
	ul ul {
		background: #fff;
		margin: 0;
		padding: 0;
	}
	ul ul li {
		border-bottom: 1px solid #ccc;
	}
	ul ul li:first-child {
		padding-top: 6px;
	}
	ul ul li:last-child {
		padding-bottom: 6px;
		border: 0;
	}
	.options {
		height: 0;
		display: block;
		overflow: hidden;
	}
	.info {
		padding: 0px 10px 0px 10px;
		.title {
			color: #feca38;
			font-weight: bold;
			font-size: 28px;
			line-height: 33px;
		}
		.confirm {
			display: flex;
			justify-content: space-between;
		}
		.container-details {
			background: #fcf7f7;
			border: 2px solid #fcf7f7;
			border-radius: 8px;
			padding: inherit;
			padding-top: 0.001rem;
			padding-bottom: 0.001rem;
			margin-bottom: 1.1rem;
		}
		.total-order {
			font-size: 18px;
		}
	}
	.confirm {
		padding: 10px;
	}

	.content-delivery {
		padding: 10px 10px 10px 10px;
		background: rgb(243, 243, 243);
		padding-bottom: 15vh;
		.title {
			font-size: 20px;
		}
		.cost {
			font-size: 23px;
			font-weight: 800;
			color: #feca38;
			display: block;
			float: right;
		}
		.sub-title {
			color: rgb(139, 139, 139);
			font-size: 14px;
			letter-spacing: 0.5px;
		}
	}
}

.content-bottom {
	box-sizing: border-box;
	position: fixed;
	bottom: 0;
	width: 100%;

	.content-restart {
		padding: 0.6em;
		background: #27ae60 !important;

		.title {
			color: #fff;
			font-size: 18px;
		}
		.icon {
			float: right;
			height: 20px;
		}
	}

	.content-total {
		background: #feca38 !important;
		border: 1px solid #feca38;
		padding: 0.8em;

		.title {
			font-size: 20px;
		}
		.sub-title {
			color: #000000;
			font-size: 14px;
			letter-spacing: 0.5px;
		}
		.cost {
			font-size: 26px;
			font-weight: 800;
			color: #000000;
			display: block;
			float: right;
		}
	}
}

.container {
	display: block;
	position: relative;
	padding-left: 35px;
	margin-bottom: 12px;
	cursor: pointer;
	-webkit-user-select: none;
	-moz-user-select: none;
	-ms-user-select: none;
	user-select: none;
}

.container input {
	position: absolute;
	opacity: 0;
	cursor: pointer;
}

/* Create a custom radio button */
.checkmark {
	position: absolute;
	top: 0;
	left: 0;
	height: 25px;
	width: 25px;
	background-color: #eee;
	border-radius: 50%;
}

.container:hover input ~ .checkmark {
	background-color: #ccc;
}

.container input:checked ~ .checkmark {
	background-color: rgb(254, 202, 56);
}

.checkmark:after {
	content: '';
	position: absolute;
	display: none;
}

.container input:checked ~ .checkmark:after {
	display: block;
}

.container .checkmark:after {
	top: 9px;
	left: 9px;
	width: 8px;
	height: 8px;
	border-radius: 50%;
	background: white;
}

.error {
	font-size: 12px;
	color: red;
	margin: auto;
}

.factura {
	text-align: center;
	margin: 0.5em;
	button {
		background: #ffffff;
		border: 1px solid #feca38;
		box-sizing: border-box;
		border-radius: 6px;
		color: #feca38;
		font-weight: 500;
		font-size: 18px;
		width: 90%;
		padding: 0.4em;
	}
}

@media (min-width: 960px) {
	.two {
		grid-column: 2 / 12 !important;
	}
	.content-restart {
		width: 70%;
	}
	.content-total {
		width: 70%;
	}
}
</style>
